﻿using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace MyCOMObj
{
    [ComVisible(true)]
    [InterfaceType(ComInterfaceType.InterfaceIsDual)]
    public interface IMySimpleObject
    {
        [DispId(1)]
        void ShowWinFormMessage([MarshalAs(UnmanagedType.LPWStr)] string text);
    }

    [ClassInterface(ClassInterfaceType.None)]
    public class MySimpleObject : IMySimpleObject
    {
        public void ShowWinFormMessage( string text)
        {
            MessageBox.Show(text);
        }
    }
}
