// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

interface IMySimpleObject : IDispatch
{
public:
	virtual HRESULT __stdcall ShowWinFormMessage(wchar_t *text) = 0;
};

int main()
{
	CoInitialize(nullptr);
	{
		CLSID refclsId = { 0, };

		CLSIDFromString(L"{C0000000-71EB-43A6-9BD1-5770A3737617}", &refclsId);
		LPVOID ppvFactoryObject = nullptr;

		HRESULT hr = CoGetClassObject(refclsId, CLSCTX_INPROC_SERVER, nullptr, IID_IClassFactory, &ppvFactoryObject);
		if (hr == S_OK)
		{
			printf("Factory: Created\n");
		}
		else
		{
			printf("Factory: Failed\n");
		}

		IClassFactory *pFactory = (IClassFactory *)ppvFactoryObject;

		IID iid = { 0, };
		IIDFromString(L"{82996B14-75F2-41FC-86A3-14C13DDD7A2C}", &iid);

		LPVOID ppvObject = nullptr;
		hr = pFactory->CreateInstance(nullptr, iid, &ppvObject);
		if (hr == S_OK)
		{
			printf("COM: Created\n");

			IMySimpleObject *pSimple = (IMySimpleObject *)ppvObject;
			pSimple->ShowWinFormMessage(L"TEST IS GOOD");
		}
		else
		{
			printf("COM: Failed\n");
		}

		{
			IMySimpleObject *pSimple2;
			hr = CoCreateInstance(refclsId, nullptr, CLSCTX_INPROC_SERVER, iid, (LPVOID *)&pSimple2);
			if (hr == S_OK)
			{
				pSimple2->ShowWinFormMessage(L"TEST IS GOOD2");
			}
		}
	}

	CoUninitialize();
    return 0;
}

